
argv = function (args) {
    var i;
    var rv = new Array();
    for(i=0;i<args.length;i++) {
        rv.push(args[i]);
    }
    return rv;
};

Hash = function () {
    var args = argv(arguments);
    var curarg;
    while(args.length) {
        if(args.length == 1) {
            throw new Error('Odd number of elements in hash assignment');
        }
        curarg = args.slice(0, 2);
        args = args.slice(2);
        this[curarg[0]] = curarg[1];
    }
    return this;
};

Hash.prototype = new Object();

Hash.prototype.toString = function () {
    var rv = new Array();
    this.enumerate(function(k,v,rv) { rv.push(k+'='+v); }, rv);
    return rv.join(',');
}

Hash.prototype.wantProperty = function (prop) {
    if(this.hasOwnProperty(prop)) {
        return 1;
    } else {
        return 0;
    }
}

Hash.prototype.keys = function () {
    var prop, rv;
    rv = new Array();
    for(prop in this) {
        if(Hash.prototype.wantProperty.call(this, prop)) {
            rv.push(prop);
        }
    }
    
    return rv;
};

Hash.prototype.values = function () {
    var prop, rv;
    rv = new Array();
    for(prop in this) {
        if(this.wantProperty(prop)) {
            rv.push(this[prop]);
        }
    }

    return rv;
};

Hash.prototype.enumerate = function (cb) {
    var prop, rv, args, i, keys;
    var args = argv(arguments).slice(1);
    rv = new Array();
    // transitional workaround to getting JSON working...
    keys = Hash.prototype.keys.call(this);

    if(keys) {
        for(i=0;i<keys.length;i++) {
            rv.push(cb.apply(this, [ keys[i], this[keys[i]] ].concat(args)));
        }
    }

    return rv;
};
